Complex Event Processing using (ESPER)
======================================

Esper: http://esper-epl-tryout.appspot.com/epltryout/mainform.html

The Yellow Cab Company in NYC is using Event Processing to help it understand the movements and revenue generated by its fleet of cabs. 
The event processing engine is using two types of events:

```
Pickup(int taxi_id, int location_id) 
```

and

```
Dropoff(int taxi_id, int location_id, int amount).

```

You job is to write a query to find the ten least profitable routes in the last 40 minutes. The profitability of a route is the sum of the amounts of all the taxi trips for that route. A route is a pair of (pickup location, dropoff location). Consider routes that ended within the last 40 minutes


Event Sequence

```
Pickup={taxiId=10, pickupLocation=1}
t=t.plus(5 minutes)
Dropoff={taxiId=10, dropoffLocation=2, amount=110}
t=t.plus(5 minutes)
Pickup={taxiId=10, pickupLocation=2}
t=t.plus(5 minutes)
Dropoff={taxiId=10, dropoffLocation=3, amount=90}
t=t.plus(5 minutes)
Pickup={taxiId=20, pickupLocation=1}
t=t.plus(5 minutes)
Dropoff={taxiId=20, dropoffLocation=3, amount= 80}
t=t.plus(5 minutes)
Pickup={taxiId=20, pickupLocation=3}
t=t.plus(5 minutes)
Dropoff={taxiId=20, dropoffLocation=1, amount=110}
t=t.plus(5 minutes)
Pickup={taxiId=20, pickupLocation=1}
t=t.plus(5 minutes)
Dropoff={taxiId=20, dropoffLocation=3, amount=100}
t=t.plus(5 minutes)
Pickup={taxiId=30, pickupLocation=1}
t=t.plus(5 minutes)
Dropoff={taxiId=30, dropoffLocation=3, amount=110}
t=t.plus(5 minutes)
Pickup={taxiId=40, pickupLocation=6}
t=t.plus(5 minutes)
Dropoff={taxiId=40, dropoffLocation=7, amount=140}
t=t.plus(5 minutes)

```

